export type IdentityType<T> = T | symbol;
export type PropertyKeyType = IdentityType<string>;

export const Type = Function;
export interface Type<T> extends Function {
  new (...args: any[]): T;
}

export type DecoratorParametersType = [any, string | symbol, number | PropertyDescriptor];

export enum PrimitiveType {
  ANY = 'any',
  STRING = 'string',
  NUMBER = 'number',
  BOOLEAN = 'boolean',
}

export enum DecoratorType {
  CLASS = 'class',
  PROPERTY = 'property',
  METHOD = 'method',
  PARAMETER = 'parameter',
}
